alter table metadata_tag drop constraint FK4EBB3A8ADCDC255F;
alter table metadata_xml drop constraint FK4EBB4B07DCDC255F;
alter table raster_data_set drop constraint FK31159ECF2CC3119A;
alter table raster_entry drop constraint FKF5FFFF3061CC1486;
alter table raster_entry_file drop constraint FK6C7AAD2BDCDC255F;
alter table raster_file drop constraint FK313A2EFE61CC1486;
alter table role_auth_user drop constraint FKFB14EF798F01F561;
alter table role_auth_user drop constraint FKFB14EF79287E0CAC;
alter table video_data_set drop constraint FKB7CED912CC3119A;
alter table video_file drop constraint FK9F8B2EC0360E7206;
drop table auth_user;
drop table metadata_tag;
drop table metadata_xml;
drop table raster_data_set;
drop table raster_entry;
drop table raster_entry_file;
drop table raster_file;
drop table repository;
drop table requestmap;
drop table role;
drop table role_auth_user;
drop table search_tag;
drop table stager_queue_item;
drop table video_data_set;
drop table video_file;
drop sequence hibernate_sequence;
create table auth_user (id int8 not null, version int8 not null, description varchar(255) not null, email varchar(255) not null, email_show bool not null, enabled bool not null, passwd varchar(255) not null, user_real_name varchar(255) not null, username varchar(255) not null unique, primary key (id));
create table metadata_tag (id int8 not null, version int8 not null, name varchar(255) not null, raster_entry_id int8 not null, value varchar(1024) not null, primary key (id));
create table metadata_xml (id int8 not null, version int8 not null, namevalue text not null, raster_entry_id int8 not null, primary key (id));
create table raster_data_set (id int8 not null, version int8 not null, repository_id int8 not null, primary key (id));
create table raster_entry (id int8 not null, version int8 not null, acquisition_date timestamp, bit_depth int4 not null, data_type varchar(255) not null, entry_id varchar(255) not null, exclude_policy varchar(255), ground_geom geometry not null, gsd_unit varchar(255), gsdx float8, gsdy float8, height int8 not null, number_of_bands int4 not null, number_of_res_levels int4, policy varchar(255), raster_data_set_id int8 not null, width int8 not null, primary key (id));
create table raster_entry_file (id int8 not null, version int8 not null, name varchar(255) not null, raster_entry_id int8 not null, type varchar(255) not null, primary key (id));
create table raster_file (id int8 not null, version int8 not null, format varchar(255) not null, name varchar(255) not null unique, raster_data_set_id int8 not null, type varchar(255) not null, primary key (id));
create table repository (id int8 not null, version int8 not null, base_dir varchar(255) not null, scan_end_date timestamp, scan_start_date timestamp, primary key (id));
create table requestmap (id int8 not null, version int8 not null, config_attribute varchar(255) not null, url varchar(255) not null unique, primary key (id));
create table role (id int8 not null, version int8 not null, authority varchar(255) not null, description varchar(255) not null, primary key (id));
create table role_auth_user (people_id int8 not null, authorities_id int8 not null, primary key (people_id, authorities_id));
create table search_tag (id int8 not null, version int8 not null, description varchar(255) not null unique, name varchar(255) not null unique, primary key (id));
create table stager_queue_item (id int8 not null, version int8 not null, base_dir varchar(255) not null, data_info text not null, file varchar(255) not null, status varchar(255) not null, primary key (id));
create table video_data_set (id int8 not null, version int8 not null, end_date timestamp, ground_geom geometry not null, height int8 not null, repository_id int8 not null, start_date timestamp, width int8 not null, primary key (id));
create table video_file (id int8 not null, version int8 not null, exclude_policy varchar(255) not null, format varchar(255) not null, name varchar(255) not null unique, policy varchar(255) not null, type varchar(255) not null, video_data_set_id int8 not null, primary key (id));
create index auth_user_username_idx on auth_user (username);
create index metadata_tag_value_idx on metadata_tag (value);
create index metadata_tag_name_idx on metadata_tag (name);
alter table metadata_tag add constraint FK4EBB3A8ADCDC255F foreign key (raster_entry_id) references raster_entry;
create index metadata_xml_namevalue_idx on metadata_xml (namevalue);
alter table metadata_xml add constraint FK4EBB4B07DCDC255F foreign key (raster_entry_id) references raster_entry;
alter table raster_data_set add constraint FK31159ECF2CC3119A foreign key (repository_id) references repository;
create index raster_entry_acquisition_date_idx on raster_entry (acquisition_date);
alter table raster_entry add constraint FKF5FFFF3061CC1486 foreign key (raster_data_set_id) references raster_data_set;
create index raster_entry_file_name_idx on raster_entry_file (name);
create index raster_entry_file_type_idx on raster_entry_file (type);
alter table raster_entry_file add constraint FK6C7AAD2BDCDC255F foreign key (raster_entry_id) references raster_entry;
create index raster_file_type_idx on raster_file (type);
create index raster_file_name_idx on raster_file (name);
create index raster_file_format_idx on raster_file (format);
alter table raster_file add constraint FK313A2EFE61CC1486 foreign key (raster_data_set_id) references raster_data_set;
create index base_dir_idx on repository (base_dir);
create index requestmap_url_idx on requestmap (url);
create index role_authority_idx on role (authority);
alter table role_auth_user add constraint FKFB14EF798F01F561 foreign key (people_id) references role;
alter table role_auth_user add constraint FKFB14EF79287E0CAC foreign key (authorities_id) references auth_user;
create index search_tag_name_idx on search_tag (name);
create index video_data_set_start_date_idx on video_data_set (start_date);
create index video_data_set_end_date_idx on video_data_set (end_date);
alter table video_data_set add constraint FKB7CED912CC3119A foreign key (repository_id) references repository;
create index video_file_type_idx on video_file (type);
create index video_file_name_idx on video_file (name);
create index video_file_format_idx on video_file (format);
alter table video_file add constraint FK9F8B2EC0360E7206 foreign key (video_data_set_id) references video_data_set;
create sequence hibernate_sequence;
