import grails.util.GrailsUtil

// locations to search for config files that get merged into the main config
// config files can either be Java properties files or ConfigSlurper scripts

// grails.config.locations = [ "classpath:${appName}-config.properties",
//                             "classpath:${appName}-config.groovy",
//                             "file:${userHome}/.grails/${appName}-config.properties",
//                             "file:${userHome}/.grails/${appName}-config.groovy"]

// if(System.properties["${appName}.config.location"]) {
//    grails.config.locations << "file:" + System.properties["${appName}.config.location"]
// }
grails.mime.file.extensions = true // enables the parsing of file extensions from URLs into the request format
grails.mime.types = [html: ['text/html', 'application/xhtml+xml'],
//    xml: ['text/xml', 'application/xml'],
    text: 'text-plain',
    js: 'text/javascript',
    rss: 'application/rss+xml',
    atom: 'application/atom+xml',
    css: 'text/css',
    csv: 'text/csv',
    all: '*/*',
    json: ['application/json', 'text/json'],
    form: 'application/x-www-form-urlencoded',
    multipartForm: 'multipart/form-data',
    kml: 'application/vnd.google+earth.kml+xml'
]
// The default codec used to encode data with ${}
grails.views.default.codec = "none" // none, html, base64
grails.views.gsp.encoding = "UTF-8"
grails.converters.encoding = "UTF-8"

// enabled native2ascii conversion of i18n properties files
grails.enable.native2ascii = true

grails.serverIP = InetAddress.localHost.hostAddress
//grails.serverIP = "172.16.90.130"

// set per-environment serverURL stem for creating absolute links
environments {
  development {
    grails.serverURL = "http://${grails.serverIP}:${System.properties['server.port'] ?: '8080'}/omar-2.0"
  }
  production {
    grails.serverURL = "http://${grails.serverIP}/omar-2.0"
  }
}

// log4j configuration
log4j = {
//  //  Comment out stdout and log to a file
//  // appender.stdout = "org.apache.log4j.ConsoleAppender"
//  // appender.'stdout.layout' = "org.apache.log4j.PatternLayout"
//  // appender.'stdout.layout.ConversionPattern' = '[%r] %c{2} %m%n'
//  appender.errors = "org.apache.log4j.FileAppender"
//  appender.'errors.layout' = "org.apache.log4j.PatternLayout"
//  appender.'errors.layout.ConversionPattern' = '[%r] %c{2} %m%n'
//  appender.'errors.File' = "logs/stacktrace.log"
//  appender.information = "org.apache.log4j.RollingFileAppender"
//  appender.'information.layout' = "org.apache.log4j.PatternLayout"
//  appender.'information.layout.ConversionPattern' = '[%r] %c{2} %m%n'
//  appender.'information.File' = "logs/omar.log"
//
//  rootLogger = "error"
//  logger {
//    grails = "error"
//    StackTrace = "error,errors"
//    org {
//      codehaus.groovy.grails.web.servlet = "error"
//      codehaus.groovy.grails.web.pages = "error"
//      codehaus.groovy.grails.web.sitemesh = "error"
//      codehaus.groovy.grails."web.mapping.filter" = "error"
//      codehaus.groovy.grails."web.mapping" = "error"
//      codehaus.groovy.grails.commons = "info"
//      codehaus.groovy.grails.plugins = "error"
//      codehaus.groovy.grails.orm.hibernate = "error"
//      springframework = "off"
//      hibernate = "off"
//    }
//  }
//
//  logger {
//    grails = "info,information"
//    org {
//// all the logging is in the controllers right now
//      codehaus.groovy.grails.app.controller = "info,information"
//      springframework = "off"
//      hibernate = "off"
//    }
//  }
//  additivity.StackTrace = false

  // Example of changing the log pattern for the default console
  // appender:
  //
  //appenders {
  //    console name:'stdout', layout:pattern(conversionPattern: '%c{2} %m%n')
  //}

  error 'org.codehaus.groovy.grails.web.servlet',  //  controllers
      'org.codehaus.groovy.grails.web.pages', //  GSP
      'org.codehaus.groovy.grails.web.sitemesh', //  layouts
      'org.codehaus.groovy.grails.web.mapping.filter', // URL mapping
      'org.codehaus.groovy.grails.web.mapping', // URL mapping
      'org.codehaus.groovy.grails.commons', // core / classloading
      'org.codehaus.groovy.grails.plugins', // plugins
      'org.codehaus.groovy.grails.orm.hibernate', // hibernate integration
      'org.springframework',
      'org.hibernate'

  warn 'org.mortbay.log'

  //trace 'org.hibernate.type'
  
}

//log4j.logger.org.springframework.security='off,stdout'

/** *********************************************************************************************************/
wms.referenceDataDirectory="/data"

wms.mapServExt = (System.properties["os.name"].startsWith("Windows")) ? ".exe" : ""
//wms.serverAddress = InetAddress.localHost.hostAddress
wms.serverAddress = grails.serverIP


wms.base.useTileCache = false
wms.base.mapFile = "${wms.referenceDataDirectory}/bmng.map"

wms.base = [
    url: (wms.base.useTileCache) ? "http://${wms.serverAddress}/tilecache/tilecache.cgi" : "http://${wms.serverAddress}/cgi-bin/mapserv${wms.mapServExt}?map=${wms.base.mapFile}",
    layers: (wms.base.useTileCache) ? "omar" : "Reference",
    title: "Reference Data",
    format: "image/jpeg"
]


wms.data.mapFile = "${wms.referenceDataDirectory}/omar-2.0-${GrailsUtil.isDevelopmentEnv() ? "dev" : "prod" }.map"
wms.data.raster = [
    url: "http://${wms.serverAddress}/cgi-bin/mapserv${wms.mapServExt}?map=${wms.data.mapFile}",
    //layers: "ImageData",
    layers: "Imagery",
    title: "OMAR Imagery Coverage",
    //format: "image/png"
    format: "image/gif"
]
wms.data.video = [
    url: "http://${wms.serverAddress}/cgi-bin/mapserv${wms.mapServExt}?map=${wms.data.mapFile}",
    //layers: "VideoData",
    layers: "Videos",
    title: "OMAR Video Coverage",
    //format: "image/png"
    format: "image/gif"    
]

thumbnail.cacheDir = (System.properties["os.name"] == "Windows XP") ? "c:/temp" : "${wms.referenceDataDirectory}/omar-cache"
thumbnail.defaultSize = 512

security.level = 'UNCLASS'
//security.level = 'SECRET'
//security.level = 'TOPSECRET'

/** *********************************************************************************************************/

videoStreaming.flashDirRoot = "/Library/WebServer/Documents/videos"
//videoStreaming.flashDirRoot = "/var/www/html/videos"
videoStreaming.flashUrlRoot = "http://${grails.serverIP}/videos"
