<%--
  Created by IntelliJ IDEA.
  User: sbortman
  Date: Feb 9, 2009
  Time: 10:19:01 AM
  To change this template use File | Settings | File Templates.
--%>

<%@ page contentType="text/html;charset=UTF-8" %>
<html>
<head><title>Simple GSP page</title>
  <title>OMAR Up is up Viewer</title>
  <link rel="stylesheet" href="${createLinkTo(dir: 'css', file: 'main.css')}"/>

  <openlayers:loadTheme theme="default"/>
  <meta name="layout" content="main"/>
  <style type="text/css">
  #map {
    width: 100%;
    height: 100%;
    border: 1px solid black;
  }

  div.olControlMousePosition {
    font-family: Verdana;
    font-size: 1.0em;
    background-color: white;
    color: black;
  }

  div.olControlScale {
    background-color: #ffffff;
    font-size: 1.0em;
    font-weight: bold;
  }

    /*
    #config {
      margin-top: 1em;
      width: 1024px;
      position: relative;
      height: 8em;
    }
    */

  #controls {
    padding-left: 2em;
    margin-left: 0;
    width: 12em;
  }

  #controls li {
    padding-top: 0.5em;
    list-style: none;
  }  </style>

  <openlayers:loadJavascript/>
</head>
<body onload="init()" onresize="changeMapSize()">
<div class="nav">
  <span class="menuButton"><a class="home" href="${createLinkTo(dir: '')}">Home</a></span>
  <span class="menuButton">
    <a href="${createLink(controller: "mapView", action: "index", params: [rasterEntryIds: rasterEntry?.id])}">
      North is up
    </a>
  </span>
  <span class="menuButton">
    <label>Stretch:</label>
    <g:select id="stretch_mode" name="stretch_mode" from="${['linear_auto_min_max', 'linear_1std_from_mean', 'linear_2std_from_mean', 'linear_3std_from_mean', 'none']}" onChange="changeHistoOpts()"/>
  </span>
  <span class="menuButton">
    <label>Region:</label>
    <g:select id="stretch_mode_region" name="stretch_mode_region" from="${['global', 'viewport']}" onChange="changeHistoOpts()"/>
  </span>
</div>
</div>
<div class="body">
  <h1 id="mapTitle">${rasterEntry?.mainFile?.name}</h1>
  <g:if test="${flash.message}">
    <div class="message">${flash.message}</div>
  </g:if>
  <div id="map"></div>
</div>
<g:javascript>
  var map;
  var layer;

  function changeMapSize()
  {
    var mapTitle = document.getElementById("mapTitle");
    var mapDiv = document.getElementById("map");

    mapDiv.style.width = mapTitle.offsetWidth + "px";
    mapDiv.style.height = Math.round(mapTitle.offsetWidth / 2) + "px";
    map.updateSize();
  }
  
 function changeHistoOpts()
{
  var stretch_mode = $("stretch_mode").value;
  var stretch_mode_region = $("stretch_mode_region").value;


  layer.mergeNewParams({stretch_mode:stretch_mode, stretch_mode_region: stretch_mode_region});
}

  function get_my_url (bounds)
  {
      var res = this.map.getResolution();
      var x = /*Math.round*/ ((bounds.left - this.maxExtent.left) / (res * this.tileSize.w));
      var y = /*Math.round*/ ((this.maxExtent.top - bounds.top) / (res * this.tileSize.h));
      var z = this.map.getZoom();
      var stretch_mode = $("stretch_mode").value;
      var stretch_mode_region = $("stretch_mode_region").value;

      var path = "?z=" + z + "&x=" + x + "&y=" + y + "&format=" + this.type
          + "&tileWidth=" + this.tileSize.w + "&tileHeight=" + this.tileSize.h
          + "&id=" + ${rasterEntry?.id} + "&stretch_mode=" + stretch_mode
          + "&stretch_mode_region=" + stretch_mode_region;

//      var path = "?bbox=" + x + "," + y + "," + bounds.right + "," + bounds.top

      var url = this.url;
      if (url instanceof Array) {
          url = this.selectUrl(path, url);
      }
      return url + path;
  }

  function init()
  {
    map = new OpenLayers.Map('map');
    map.addControl(new OpenLayers.Control.LayerSwitcher())
    map.addControl(new OpenLayers.Control.PanZoom())
    map.addControl(new OpenLayers.Control.NavToolbar())
    map.addControl(new OpenLayers.Control.MousePosition());
    map.addControl(new OpenLayers.Control.Scale());
    map.addControl(new OpenLayers.Control.ScaleLine());

    var options = {
      maxExtent: new OpenLayers.Bounds(0,0,${width},${height}),
      maxResolution: ${width} / map.getTileSize().w,
        numZoomLevels: 30,
//        numZoomLevels: ${numRLevels},
      type:'jpeg',
      getURL: get_my_url,
      isBaseLayer: true,
      buffer: 1,
      singleTile: true,
      ratio: 1.0,
      transitionEffect: "resize"
    };


    layer = new OpenLayers.Layer.TMS("Layer",
        "${createLink(controller: 'ogc', action: 'getTile')}",
        options
    );


    changeMapSize();
    
    map.addLayers([layer]);
    map.zoomToMaxExtent();

  }
</g:javascript>

</body>
</html>