<%--
  Created by IntelliJ IDEA.
  User: sbortman
  Date: Sep 26, 2008
  Time: 11:04:28 AM
  To change this template use File | Settings | File Templates.
--%>

<%@ page contentType="text/html;charset=UTF-8" %>
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
  <meta name="layout" content="main"/>
  <title>OMAR North is up Viewer</title>
  <link rel="stylesheet" href="${createLinkTo(dir: 'css', file: 'main.css')}"/>

  <openlayers:loadTheme theme="default"/>

  <style type="text/css">
  #map {
    width: 100%;
    height: 100%;
    border: 1px solid black;
  }

  div.olControlMousePosition {
    font-family: Verdana;
    font-size: 1.0em;
    background-color: white;
    color: black;
  }

  div.olControlScale {
    background-color: #ffffff;
    font-size: 1.0em;
    font-weight: bold;
  }

    /*
    #config {
      margin-top: 1em;
      width: 1024px;
      position: relative;
      height: 8em;
    }
    */

  #controls {
    padding-left: 2em;
    margin-left: 0;
    width: 12em;
  }

  #controls li {
    padding-top: 0.5em;
    list-style: none;
  }

  </style>

  <openlayers:loadJavascript/>
</head>
<body onload="init();" onresize="changeMapSize();">
<div class="nav">
  <span class="menuButton"><a class="home" href="${createLinkTo(dir: '')}">Home</a></span>
  <span class="menuButton">
    <a href="${createLink(controller: "ogc", action: "wms", params: [request: "GetCapabilities", layers: (rasterEntries*.id).join(',')])}">
      WMS GetCapabilities
    </a>
  </span>
  <span class="menuButton">
    <a href="${createLink(controller: "ogc", action: "wms", params: [request: "GetKML", layers: (rasterEntries*.id).join(',')])}">
      Generate KML
    </a>
  </span>
  <span class="menuButton">
    <a href="${createLink(controller: "mapView", action: "multiLayer", params: [rasterEntryIds: (rasterEntries*.id).join(',')])}">
      Multi-Layer
    </a>
  </span>
  <g:if test="${rasterEntries?.size() == 1}">
    <span class="menuButton">
      <a href="${createLink(controller: "mapView", action: "imageSpace", id: (rasterEntries*.id).join(','))}">
        Up is up
      </a>
    </span>
  </g:if>
  <span class="menuButton">
    <label>Stretch:</label>
    <g:select id="stretch_mode" name="stretch_mode" from="${['linear_auto_min_max', 'linear_1std_from_mean', 'linear_2std_from_mean', 'linear_3std_from_mean', 'none']}" onChange="changeHistoOpts()"/>
  </span>
  <span class="menuButton">
    <label>Region:</label>
    <g:select id="stretch_mode_region" name="stretch_mode_region" from="${['global', 'viewport']}" onChange="changeHistoOpts()"/>
  </span>
</div>
<div class="body">
  <h1 id="mapTitle">${rasterEntries*.mainFile.name}</h1>
  <g:if test="${flash.message}">
    <div class="message">${flash.message}</div>
  </g:if>
  <div id="map"></div>
</div>
<g:javascript>
  var map;
  var rasterLayers;
  var kmlLayers;
  var select;
  
  function changeMapSize()
  {
    var mapTitle = document.getElementById("mapTitle");
    var mapDiv = document.getElementById("map");

    mapDiv.style.width = mapTitle.offsetWidth + "px";
    mapDiv.style.height = Math.round(mapTitle.offsetWidth / 2) + "px";
    map.updateSize();
  }
  function init()
  {
    var left = "${left}";
    var bottom = "${bottom}";
    var right = "${right}";
    var top = "${top}";

    map = new OpenLayers.Map("map", { controls: [], numZoomLevels: 32 });

    var bounds = new OpenLayers.Bounds(left, bottom, right, top);

    map.maxExtent = bounds;
    changeMapSize();


    setupLayers();

    map.addControl(new OpenLayers.Control.LayerSwitcher());
    map.addControl(new OpenLayers.Control.PanZoom());
    map.addControl(new OpenLayers.Control.NavToolbar());
    map.addControl(new OpenLayers.Control.MousePosition());
    map.addControl(new OpenLayers.Control.Scale());
    map.addControl(new OpenLayers.Control.ScaleLine());


    var zoom = map.getZoomForExtent(bounds, true);

    map.setCenter(bounds.getCenterLonLat(), zoom);
  }

  function setupLayers()
  {

    var format = "image/jpeg";
    //      var format = "image/png";
    //      var format = "image/gif";
    var transparent = false;


    var stretch_mode = $("stretch_mode").value;
    var stretch_mode_region = $("stretch_mode_region").value;


     rasterLayers = [
      new OpenLayers.Layer.WMS( "Raster", "${createLink(controller: 'ogc', action: 'wms')}",
      { layers: "${(rasterEntries*.id).join(',')}", format: format, stretch_mode:stretch_mode, stretch_mode_region: stretch_mode_region, transparent:transparent  },
      {isBaseLayer: true, buffer:1, singleTile:true, ratio:1.0, transitionEffect: "resize"})
    ];

    map.addLayers(rasterLayers);

       <g:each in="${kmlOverlays}" var="kmlOverlay" status="i">

         if ( ! kmlLayers ) {
            kmlLayers = new Array();
         }

    var kmlLayer =  new OpenLayers.Layer.Vector("${kmlOverlay.name}", {
      projection: map.displayProjection,
      strategies: [new OpenLayers.Strategy.Fixed()],
      protocol: new OpenLayers.Protocol.HTTP({
        url: "${kmlOverlay.url}",
        format: new OpenLayers.Format.KML({
          extractStyles: true,
          extractAttributes: true
        })
      })
     });
     
    kmlLayers[${i}] = kmlLayer;
    kmlLayer.events.on({
        "featureselected": onFeatureSelect,
        "featureunselected": onFeatureUnselect
    });

    map.addLayers(kmlLayers);
   select = new OpenLayers.Control.SelectFeature(kmlLayers);
    map.addControl(select);
    select.activate();

  </g:each>




  }

  function onPopupClose(evt)
  {
      select.unselectAll();
  }

  function onFeatureSelect(event)
  {
      var feature = event.feature;
      // Since KML is user-generated, do naive protection against
      // Javascript.
      var content = "<h2>"+feature.attributes.name + "</h2>" + feature.attributes.description;
      if (content.search("<script") != -1) {
          content = "Content contained Javascript! Escaped content below.<br />" + content.replace(/</g, "&lt;");
      }
      popup = new OpenLayers.Popup.FramedCloud("chicken",
                               feature.geometry.getBounds().getCenterLonLat(),
                               new OpenLayers.Size(100,100),
                               content,
                               null, true, onPopupClose);
      feature.popup = popup;
      map.addPopup(popup);
  }

  function onFeatureUnselect(event)
  {
      var feature = event.feature;
      if(feature.popup) {
          map.removePopup(feature.popup);
          feature.popup.destroy();
          delete feature.popup;
      }
  }

  function changeHistoOpts()
  {
    var stretch_mode = $("stretch_mode").value;
    var stretch_mode_region = $("stretch_mode_region").value;

    for ( var layer in rasterLayers )
    {
      rasterLayers[layer].mergeNewParams({stretch_mode:stretch_mode, stretch_mode_region: stretch_mode_region});
    }
  }
</g:javascript>

</body>
</html>
