<%--
  Created by IntelliJ IDEA.
  User: sbortman
  Date: Sep 26, 2008
  Time: 11:04:28 AM
  To change this template use File | Settings | File Templates.
--%>

<%@ page contentType="text/html;charset=UTF-8" %>
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
  <meta name="layout" content="main"/>
  <title>OMAR North is up Multi-Viewer</title>
  <link rel="stylesheet" href="${createLinkTo(dir: 'css', file: 'main.css')}"/>

  <openlayers:loadTheme theme="default"/>

  <style type="text/css">
  #map {
    width: 100%;
    height: 100%;
    border: 1px solid black;
  }

  div.olControlMousePosition {
    font-family: Verdana;
    font-size: 1.0em;
    background-color: white;
    color: black;
  }

  div.olControlScale {
    background-color: #ffffff;
    font-size: 1.0em;
    font-weight: bold;
  }

    /*
    #config {
      margin-top: 1em;
      width: 1024px;
      position: relative;
      height: 8em;
    }
    */

  #controls {
    padding-left: 2em;
    margin-left: 0;
    width: 12em;
  }

  #controls li {
    padding-top: 0.5em;
    list-style: none;
  }

  </style>

  <openlayers:loadJavascript/>
  <script type="text/javascript">
    var map;

    function changeMapSize()
    {
      var mapTitle = document.getElementById("mapTitle");
      var mapDiv = document.getElementById("map");

      mapDiv.style.width = mapTitle.offsetWidth + "px";
      mapDiv.style.height = Math.round(mapTitle.offsetWidth / 2) + "px";
      map.updateSize();
    }
    function init()
    {
      var left = ${left};
      var bottom = ${bottom};
      var right = ${right};
      var top = ${top};

      map = new OpenLayers.Map("map", { controls: [], numZoomLevels: 32 });

      var format = "image/png";
      var transparent = true;

      var baseLayer = new OpenLayers.Layer.WMS(
              "${baseWMS.title}",
              "${baseWMS.url}",
      {layers: '${baseWMS.layers}', format: 'image/jpeg' },
      {buffer:1}
              );

      map.addLayer(baseLayer);

      var layers = [



        <g:each var="rasterEntry" in="${rasterEntries}" status="i">

        <g:if test="${i > 0}">,</g:if>

        new OpenLayers.Layer.WMS(
                "Raster ${rasterEntry.id}",
                "${createLink( controller:'ogc', action:'wms')}",
        { layers: "${rasterEntry.id}", format: format, stretch_mode:"linear_auto_min_max", transparent:transparent  },
        {isBaseLayer: false, buffer:1, singleTile:true, transitionEffect: "resize"}
                )
        <g:if test="${hasKML}">

        , new OpenLayers.Layer.Vector("KML", {
          projection: map.displayProjection,
          strategies: [new OpenLayers.Strategy.Fixed()],
          protocol: new OpenLayers.Protocol.HTTP({
            url: "${createLink( controller:'rasterEntry', action:'getKML', params:[rasterEntryIds:rasterEntry.id])}",
            format: new OpenLayers.Format.KML({
              extractStyles: true,
              extractAttributes: true
            })
          })
        })
        </g:if>
        </g:each>
      ];


      map.addLayers(layers);
      map.addControl(new OpenLayers.Control.LayerSwitcher())
      map.addControl(new OpenLayers.Control.PanZoom())
      map.addControl(new OpenLayers.Control.NavToolbar())
      map.addControl(new OpenLayers.Control.MousePosition());
      map.addControl(new OpenLayers.Control.Scale());
      map.addControl(new OpenLayers.Control.Permalink("permalink"));
      map.addControl(new OpenLayers.Control.ScaleLine());
      map.addControl(new OpenLayers.Control.Attribution());



      var bounds = new OpenLayers.Bounds(left, bottom, right, top);

      map.maxExtent = bounds;
      changeMapSize();
      
      var zoom = map.getZoomForExtent(bounds, true);

      map.setCenter(bounds.getCenterLonLat(), zoom);
    }
  </script>

</head>
<body onload="init()" onresize="changeMapSize()">
<div class="nav">
  <span class="menuButton"><a class="home" href="${createLinkTo(dir: '')}">Home</a></span>
  <span class="menuButton">
    <a href="${createLink(controller: "ogc", action: "wms", params: [request: "GetCapabilities", layers: (rasterEntries*.id).join(',')])}">
      WMS GetCapabilities
    </a>
  </span>
  <span class="menuButton">
    <a href="${createLink(controller: "ogc", action: "wms", params: [request: "GetKML", layers: (rasterEntries*.id).join(',')])}">
      Generate KML
    </a>
  </span>
  <span class="menuButton">
    <a href="${createLink(controller: "mapView", action: "index", params: [rasterEntryIds: (rasterEntries*.id).join(',')])}">
     Single Layer
    </a>
  </span>
  <g:if test="${rasterEntries?.size() == 1}">
    <span class="menuButton">
      <a href="${createLink(controller: "mapView", action: "imageSpace", id: (rasterEntries*.id).join(','))}">
        Up is up
      </a>
    </span>
  </g:if>

</div>
<div class="body">
  <h1 id="mapTitle">${rasterEntries*.mainFile.name}</h1>
  <g:if test="${flash.message}">
    <div class="message">${flash.message}</div>
  </g:if>
  <div id="map"></div>
</div>
</body>
</html>
