<%--
  Created by IntelliJ IDEA.
  User: sbortman
  Date: Sep 14, 2009
  Time: 9:24:47 AM
  To change this template use File | Settings | File Templates.
--%>

<%@ page contentType="text/html;charset=UTF-8" %>
<html>
<head>
  <title>New Search Page</title>
  <meta name="layout" content="main3"/>
  <link rel="stylesheet" href="${createLinkTo(dir: 'css', file: 'mapwidget.css')}"/>

  <style type="text/css">
  #map {
    border: 1px solid black;
    width: 100%;
    height: 100%;
  }

  #controls {
    padding-left: 2em;
    margin-left: 0;
    width: 12em;
  }

  #controls li {
    padding-top: 0.5em;
    list-style: none;
  }

  #panel {
    right: 0px;
    height: 30px;
    width: 200px;
  }

  #panel div {
    float: left;
    margin: 5px;
  }
  </style>


  <openlayers:loadTheme theme="default"/>
  <openlayers:loadJavascript/>
  <resource:dateChooser/>

  <g:javascript src="foo.js"/>
  <g:javascript>
      function init()
      {
        var baseWMS = {
          title: "${baseWMS.title}",
          url: "${baseWMS.url}",
          layers: "${baseWMS.layers}"
        };

        var aoiMinLon = "${queryParams?.aoiMinLon ?: ''}";
        var aoiMinLat = "${queryParams?.aoiMinLat ?: ''}";
        var aoiMaxLon = "${queryParams?.aoiMaxLon ?: ''}";
        var aoiMaxLat = "${queryParams?.aoiMaxLat ?: ''}";

        var viewMinLon = "${queryParams?.viewMinLon ?: -180}";
        var viewMinLat = "${queryParams?.viewMinLat ?: -90}";
        var viewMaxLon = "${queryParams?.viewMaxLon ?: 180}";
        var viewMaxLat = "${queryParams?.viewMaxLat ?: 90}";

        var mapWidget = new MapWidget(
          baseWMS,
          aoiMinLon,
          aoiMinLat,
          aoiMaxLon,
          aoiMaxLat,
          viewMinLon,
          viewMinLat,
          viewMaxLon,
          viewMaxLat
        );

        mapWidget.setupMapWidget();
        //setupDataLayer();
        mapWidget.setupAoiLayer();
        mapWidget.setupToolbar();
        mapWidget.setupBaseLayer();
        mapWidget.changeMapSize();
        mapWidget.setupMapView();
        mapWidget.setupCallbacks();
        //updateOmarFilters();

      }
  </g:javascript>

</head>
<body class="yui-skin-sam">
<content tag="banner">
  <img id="logo" src="${createLinkTo(dir: 'images', file: 'OMARLarge.png', absolute)}" alt="OMAR-2.0 Logo"/>
</content>
<content tag="main">
  <div id="nav" class="nav">
    <span class="menuButton">
      <a class="home" href="${createLinkTo(dir: '')}">Home</a>
    </span>
  </div>
  <div class="body">
    <h1 id="mapTitle">Search for Imagery:</h1>
    <g:if test="${flash.message}">
      <div class="message">${flash.message}</div>
    </g:if>
    <div id="map"></div>

  </div>
</content>
<content tag="search">
  <g:form>
    <div class="niceBox">
      <div class="niceBoxHd">Map Center:</div>
      <div class="niceBoxBody">
        <ol>
          <li>
            <label for='centerLon'>Lon:</label><br/>
          </li>
          <li>
            <input type="text" id="centerLon" name="center"/>
          </li>
          <li>
            <label for='centerLat'>Lat:</label>
          </li>
          <li>
            <input type="text" id="centerLat" name="center"/>
          </li>
          <li><br/></li>
          <li>
            <input type="checkbox" id="radiusact" name="radiusact"
                    value="${fieldValue(bean: queryParams, field: 'radiusact')}" onclick="toggleRadiusSearch()"/>
            <label for="radiusact">Use Radius Search</label>
          </li>
          <li><br/></li>
          <li>
            <label for='aoiRadius'>Radius in Meters:</label><br/>
          </li>
          <li>
            <input type="text" id="aoiRadius" name="aoiRadius" value="${fieldValue(bean: queryParams, field: 'aoiRadius')}"/>
          </li>
          <li><br/></li>
          <li>
            <span class="formButton">
              <input type="button" onclick="goto()" value="Set Center">
            </span>
          </li>
        </ol>
      </div>
    </div>

    <div class="niceBox">
      <div class="niceBoxHd">Geospatial Criteria:</div>
      <div class="niceBoxBody">
        <input type="hidden" id="viewMinLon" name="viewMinLon" value="${fieldValue(bean: queryParams, field: 'viewMinLon')}"/>
        <input type="hidden" id="viewMinLat" name="viewMinLat" value="${fieldValue(bean: queryParams, field: 'viewMinLat')}"/>
        <input type="hidden" id="viewMaxLon" name="viewMaxLon" value="${fieldValue(bean: queryParams, field: 'viewMaxLon')}"/>
        <input type="hidden" id="viewMaxLat" name="viewMaxLat" value="${fieldValue(bean: queryParams, field: 'viewMaxLat')}"/>
        <ol>
          <li>
            <input type="checkbox" id="bboxact" name="bboxact"
                    value="${fieldValue(bean: queryParams, field: 'bboxact')}" onclick="toggleBboxSearch()"/>
            <label for="radiusact">Use BBox Search</label>
          </li>
          <li><br/></li>
          <li>
            <label for='aoiMinLon'>West Lon:</label>
          </li>
          <li>
            <input type="text" id="aoiMinLon" name="aoiMinLon" value="${fieldValue(bean: queryParams, field: 'aoiMinLon')}"/>
          </li>
          <li>
            <label for='aoiMaxLat'>North Lat:</label>
          </li>
          <li>
            <input type="text" id="aoiMaxLat" name="aoiMaxLat" value="${fieldValue(bean: queryParams, field: 'aoiMaxLat')}"/>
          </li>
          <li>
            <label for='aoiMaxLon'>East Lon:</label>
          </li>
          <li>
            <input type="text" id="aoiMaxLon" name="aoiMaxLon" value="${fieldValue(bean: queryParams, field: 'aoiMaxLon')}"/>
          </li>
          <li>
            <label for='aoiMinLat'>South Lat:</label>
          </li>
          <li>
            <input type="text" id="aoiMinLat" name="aoiMinLat" value="${fieldValue(bean: queryParams, field: 'aoiMinLat')}"/>
          </li>
          <li><br/></li>
          <li>
            <input type="button" onclick="clearAOI()" value="Clear AOI">
          </li>
        </ol>
      </div>
    </div>

    <div class="niceBox">
      <div class="niceBoxHd">Temporal Criteria:</div>
      <div class="niceBoxBody">
        <ol>
          <li>
            <label for='startDate'>Start Date:</label>
          </li>
          <li>
            <richui:dateChooser name="startDate" format="MM/dd/yyyy" value="${queryParams.startDate}"></richui:dateChooser>
          </li>
          <li>
            <label for='endDate'>End Date:</label>
          </li>
          <li>
            <richui:dateChooser name="endDate" format="MM/dd/yyyy" value="${queryParams.endDate}"></richui:dateChooser>
          </li>
          <li><br/></li>
          <li>
            <input type="button" onclick="updateOmarFilters()" value="Update Footprints">
          </li>
        </ol>
      </div>
    </div>

    <div class="niceBox">
      <div class="niceBoxHd">Metadata Criteria:</div>
      <div class="niceBoxMetadataBody">
        <ol>
          <g:each in="${1..8}">
            <li>
              <g:select id="searchTag${it}.id" name='searchTag${it}.id' value="searchTag${it}.id"
                      noSelection="${['null':'Select One...']}"
                      from='${SearchTag.list()}'
                      optionKey="id" optionValue="description"></g:select>
            </li>
            <li>
              <%--
              <g:textField name="searchTagValue${it}" value="${fieldValue(bean: queryParams, field: "${searchTagValue"${it}"}")}"/>
              --%>
              <g:textField name="searchTagValue${it}" value="${queryParams?.searchTagValue"${it}"}"/>

            </li>
          </g:each>
        </ol>
      </div>
    </div>

    <div class="niceBox">
      <div class="niceBoxHd">Options:</div>
      <div class="niceBoxBody">
        <ol>
          <li><label for="max">Max Results:</label></li>
          <li><input type="text" id="max" name="max" value="${params?.max}"></li>
        </ol>
      </div>
    </div>
    <br/>
    <g:actionSubmit value="Search"/>&nbsp;<g:actionSubmit action="kmlnetworklink" value="KML"/>
  </g:form>
</content>
<content tag="contentinfo">
</content>
</body>
</html>