class StagerHandler
{
  def prefix
  def all
  def skipped
  def success
  def failure
  def rejected
  def data

  public StagerHandler(String output=".", String prefix="oms")
  {
    File logDir = new File(output)

    if (!logDir.exists())
      logDir.mkdir()
    
    all = new File(logDir, "${prefix}-all.txt")
    skipped = new File(logDir, "${prefix}-skipped.txt")
    success = new File(logDir, "${prefix}-success.txt")
    failure = new File(logDir, "${prefix}-failure.txt")
    rejected = new File(logDir, "${prefix}-rejected.txt")
    data = new File(logDir, "${prefix}-data.dat")
    all.write("")
    skipped.write("")
    success.write("")
    failure.write("")
    rejected.write("")
    data.write("")
  }

  def processAll(File imageFile)
  {
    all << imageFile << "\n"
  }

  def processSuccessful(File imageFile, def results)
  {
    success << imageFile << "\n"

    results = results.replace('\n', '')
    data << results << "\n"
  }

  def processFailure(File imageFile)
  {
    failure << imageFile << "\n"
  }

  def processSkipped(File imageFile)
  {
    skipped << imageFile << "\n"
  }

  def processRejected(File imageFile)
  {
    rejected << imageFile << "\n"
  }

}
